diff --git a/src/fios_gui.cpp b/src/fios_gui.cpp
--- a/src/fios_gui.cpp
+++ b/src/fios_gui.cpp
@@ -36,7 +36,6 @@
 static bool _fios_path_changed;
 static bool _savegame_sort_dirty;
 
-
 /**
  * Reset read data.
  */
@@ -198,7 +197,7 @@
 /** Colours for fios types, indexed by #FiosType. */
 const TextColour _fios_colours[] = {
 	TC_LIGHT_BLUE, TC_DARK_GREEN,  TC_DARK_GREEN, TC_ORANGE, TC_LIGHT_BROWN,
-	TC_ORANGE,     TC_LIGHT_BROWN, TC_ORANGE,     TC_ORANGE, TC_YELLOW
+	TC_ORANGE,     TC_LIGHT_BROWN, TC_ORANGE,     TC_ORANGE, TC_YELLOW, TC_ORANGE
 };
 
 void BuildFileList()
@@ -213,6 +212,9 @@
 		case SLD_SAVE_HEIGHTMAP:
 		case SLD_LOAD_HEIGHTMAP:
 			FiosGetHeightmapList(_saveload_mode); break;
+		case SLD_LOAD_TEMPLATE: // TODO: fix saving/loading of templates (game crashes when trying to do so)
+		case SLD_SAVE_TEMPLATE:
+			FiosGetTemplateList(_saveload_mode); break;
 
 		default: FiosGetSavegameList(_saveload_mode); break;
 	}
@@ -265,6 +267,8 @@
 			STR_SAVELOAD_SAVE_SCENARIO,
 			STR_SAVELOAD_LOAD_HEIGHTMAP,
 			STR_SAVELOAD_SAVE_HEIGHTMAP,
+			STR_SAVELOAD_SAVE_COPY_PASTE_TEMPLATE,
+			STR_SAVELOAD_LOAD_COPY_PASTE_TEMPLATE,
 		};
 		assert((uint)mode < lengthof(saveload_captions));
 
@@ -273,6 +277,7 @@
 		switch (mode) {
 			case SLD_SAVE_GAME:     this->GenerateFileName(); break;
 			case SLD_SAVE_HEIGHTMAP:
+			case SLD_SAVE_TEMPLATE:
 			case SLD_SAVE_SCENARIO: strecpy(this->edit_str_buf, "UNNAMED", &this->edit_str_buf[edit_str_size - 1]); break;
 			default:                break;
 		}
@@ -302,6 +307,8 @@
 
 		o_dir.type = FIOS_TYPE_DIRECT;
 		switch (_saveload_mode) {
+			case SLD_SAVE_TEMPLATE:
+			case SLD_LOAD_TEMPLATE:
 			case SLD_SAVE_GAME:
 			case SLD_LOAD_GAME:
 				FioGetDirectory(o_dir.name, lengthof(o_dir.name), SAVE_DIR);
@@ -322,7 +329,7 @@
 		}
 
 		/* Focus the edit box by default in the save windows */
-		if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP) {
+		if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP || _saveload_mode == SLD_SAVE_TEMPLATE) {
 			this->SetFocusedWidget(SLWW_SAVE_OSK_TITLE);
 		}
 	}
@@ -507,7 +514,7 @@
 		this->vscroll->SetCount(_fios_items.Length());
 		this->DrawWidgets();
 
-		if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP) {
+		if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP || _saveload_mode == SLD_SAVE_TEMPLATE) {
 			this->DrawEditBox(SLWW_SAVE_OSK_TITLE);
 		}
 	}
@@ -573,7 +580,11 @@
 
 							this->InvalidateData(1);
 						}
-						if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP) {
+					    if (_saveload_mode == SLD_LOAD_TEMPLATE) {
+							/* Load template file here */
+							_switch_mode = SM_LOAD_TEMPLATE;
+							ttd_strlcpy(_file_to_saveload.name, name, sizeof(_file_to_saveload.name));
+						} else if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP) {
 							/* Copy clicked name to editbox */
 							ttd_strlcpy(this->text.buf, file->title, this->text.max_bytes);
 							UpdateTextBufferSize(&this->text);
@@ -620,7 +631,7 @@
 
 	virtual void OnMouseLoop()
 	{
-		if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP) {
+		if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP || _saveload_mode == SLD_SAVE_TEMPLATE) {
 			this->HandleEditBox(SLWW_SAVE_OSK_TITLE);
 		}
 	}
@@ -633,7 +644,7 @@
 		}
 
 		EventState state = ES_NOT_HANDLED;
-		if ((_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP) &&
+		if ((_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP ||_saveload_mode == SLD_SAVE_TEMPLATE) &&
 				this->HandleEditBoxKey(SLWW_SAVE_OSK_TITLE, key, keycode, state) == HEBR_CONFIRM) {
 			this->HandleButtonClick(SLWW_SAVE_GAME);
 		}
@@ -645,7 +656,7 @@
 	{
 		/* This test protects against using widgets 11 and 12 which are only available
 		 * in those saveload modes. */
-		if (!(_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP)) return;
+		if (!(_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO || _saveload_mode == SLD_SAVE_HEIGHTMAP || _saveload_mode == SLD_SAVE_TEMPLATE)) return;
 
 		if (this->IsWidgetLowered(SLWW_DELETE_SELECTION)) { // Delete button clicked
 			if (!FiosDelete(this->text.buf)) {
@@ -658,7 +669,11 @@
 
 			UpdateTextBufferSize(&this->text);
 		} else if (this->IsWidgetLowered(SLWW_SAVE_GAME)) { // Save button clicked
-			if (_saveload_mode  == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO) {
+			if (_saveload_mode == SLD_SAVE_TEMPLATE) {
+				/* Do Template Saving here */
+				_switch_mode = SM_SAVE_TEMPLATE;
+				FiosMakeSavegameName(_file_to_saveload.name, this->text.buf, sizeof(_file_to_saveload.name));
+			} else if (_saveload_mode  == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO) {
 				_switch_mode = SM_SAVE_GAME;
 				FiosMakeSavegameName(_file_to_saveload.name, this->text.buf, sizeof(_file_to_saveload.name));
 			} else {
@@ -759,6 +774,7 @@
 	const WindowDesc *sld;
 	switch (mode) {
 		case SLD_SAVE_GAME:
+		case SLD_SAVE_TEMPLATE:
 		case SLD_SAVE_SCENARIO:
 		case SLD_SAVE_HEIGHTMAP:
 			sld = &_save_dialog_desc; break;
